/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.se.eip;

/**
 * Configuration constants.
 * @author Adrien Louis - EBM WebSourcing
 */
public interface EIPConstants {

    public final static String ACTION = "eip";

    public final static String TEST = "test";

    public final static String TEST_OPERATION = "test-operation";

    public final static String NAMESPACE = "http://petals.ow2.org/components/eip/version-2";

    public final static String RESULT_ELEMENT = "result";

    /**
     * If true, a fault received doesn't stop the treatment.<br />
     * For the WithOut patterns, the fault message is added to the concatenated
     * response
     */
    public final static String FAULT_ROBUST = "fault-robust";

    /**
     * If true, an exception received doesn't stop the treatment.<br />
     * For the WithOut patterns, the exception message is added to the
     * concatenated response
     */
    public final static String EXCEPTION_ROBUST = "exception-robust";

    /**
     * If true, a fault received from the target service is transformed to an
     * exception into the source exchange.<br />
     */
    public final static String FAULT_TO_EXCEPTION = "fault-to-exception";

    /**
     * If true, the message content is ignored, and each xml attachment file is
     * transformed to a message in content.<br />
     */
    public final static String ATTACHMENT_MODE = "attachment-mode";

    /**
     * The fault element used to return a fault into an out message, when the
     * pattern is fault robust
     */
    public final static String FAULT_ELEMENT = "fault";

    /**
     * The exception element used to return a fault into an out message, when
     * the pattern is exception robust
     */
    public final static String EXCEPTION_ELEMENT = "exception";

    public static final String WIRE_TAP_WAY = "wiretap-way";

    public static final String AGGREGATOR_CORRELATION = "aggregator-correlation";
}
