/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.se.eip.async;

import java.util.List;

import org.ow2.petals.component.framework.api.message.Exchange;
import org.ow2.petals.component.framework.jbidescriptor.generated.Consumes;
import org.ow2.petals.se.eip.patterns.RoutingSlip;

/**
 * @author Frederic Gardes - EBM WebSourcing
 */
public class RoutingSlipAsyncContext extends CommonAsyncContext {

    private List<Consumes> consumesList = null;

    /**
     * The Constructor
     * 
     * @param originalExchange
     * @param timeToLive
     * @param consumesList
     * @param faultToException
     */
    protected RoutingSlipAsyncContext(final Exchange originalExchange, final Long timeToLive,
            final String pattern, final int ongoingSubMessages, final boolean faultToException,
            final List<Consumes> consumesList) {
        super(originalExchange, timeToLive, pattern, ongoingSubMessages, false, false,
                faultToException);
        this.consumesList = consumesList;
    }

    /**
     * The Constructor
     * 
     * @param originalExchange
     * @param timeToLive
     * @param consumesList
     * @param faultToException
     */
    public RoutingSlipAsyncContext(final Exchange originalExchange, final Long timeToLive,
            final boolean faultToException, final List<Consumes> consumesList) {
        super(originalExchange, timeToLive, RoutingSlip.ROUTING_SLIP_NAME, consumesList.size(),
                false, false, faultToException);
        this.consumesList = consumesList;
    }

    /**
     * Get the consumesList
     * 
     * @return the consumesList
     */
    public List<Consumes> getConsumesList() {
        return this.consumesList;
    }

}
