/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.se.eip.patterns;

import java.util.List;
import java.util.Vector;

import javax.xml.namespace.QName;
import javax.xml.xpath.XPathExpressionException;

import org.ow2.petals.component.framework.api.configuration.ConfigurationExtensions;
import org.ow2.petals.component.framework.api.message.Exchange;
import org.ow2.petals.se.eip.EIPConstants;

/**
 * Helper to route.
 * @author Frederic Gardes - EBM WebSourcing
 */
public class OperationRouterEngine implements RouterEngine {

    /**
     * @param extensions
     * @return
     */
    public List<String> getOperationParameters(final ConfigurationExtensions extensions) {
        final Vector<String> operationParameters = new Vector<String>();
        for (final String param : extensions.keySet()) {
            if (EIPConstants.TEST_OPERATION.equals(param)) {
                operationParameters.add(extensions.get(param));
                break;
            } else if (param.startsWith(EIPConstants.TEST_OPERATION)) {
                final String indexString = param.substring(EIPConstants.TEST_OPERATION.length());
                int index = Integer.valueOf(indexString);
                if (index > operationParameters.size()) {
                    operationParameters.setSize(index);
                }
                operationParameters.set(index - 1, extensions.get(param));
            }
        }

        return operationParameters;
    }

    /**
     * @param conditions
     * @param inMessage
     * @return
     * @throws XPathExpressionException
     */
    public int route(final List<String> conditions, final Exchange exchange)
            throws XPathExpressionException {
        int targetedConsumesListIndentifier = conditions.size();
        for (int i = 0; i < conditions.size(); i++) {
            if (exchange.getOperation().equals(QName.valueOf(conditions.get(i)))) {
                targetedConsumesListIndentifier = i;
                break;
            }
        }
        return targetedConsumesListIndentifier;
    }
}
